close all
clear all
clc

% Inicializacin de variables

    s21_opt_db = 0;
    s21_db = 0;
    s11_opt_db = 0;
    s11_db = 0;  
    frecuencia =  3.3e9:0.1e9:4.9e9;
    
% Clculo de valores ptimos
    tan_perd_opt = 0.02;
    er_opt = 9.8;

    [s11_opt, s21_opt] = funcion_s_gradiente(er_opt,tan_perd_opt,frecuencia);
         
% Conversin a dBs
    s21_opt_db = 20*log10(abs(s21_opt));
    s11_opt_db = 20*log10(abs(s11_opt));

% Representacin de resultados

    figure, plot(frecuencia, s11_opt_db);
    hold on
    plot(frecuencia, s21_opt_db,'g');
    xlabel('Frequency (Hz)')
    ylabel('S-Parameters (dB)')
    title('S-Parameters (Ideal Solution, complex permittivity)')
%     title('S-Parameters (Ideal Solution, real permittivity)')
    legend('S11 Parameter', 'S21 Parameter')
    hold off
    
    
    