function [ coste_act , iteracion ] = Funcion_Descenso_gradiente( er_opt, tan_perd_opt, er_ini, tan_perd_ini, delta_er, delta_tan_perd )
    
    % Inicializacin de variables
%     vector_coste = [];
%     vector_er = [];
%     vector_tan_perd = [];
    
%     vector_iteracion = [];
% for mu = 0.01:0.01:1
%     mu
    frecuencia =  linspace(3.3e9, 4.9e9, 17);
    iteracion = 1;
    dC_er = 0.1;

    eta = 0.5;
    chi = 0.5;
    mu = 0.15;

    er = er_ini;
    tan_perd = tan_perd_ini;

%     vector_er = [vector_er er];
%     vector_tan_perd = [vector_tan_perd tan_perd];

    coste_act = 1;
    er_final = 0;
    tan_final = 0; 

    % Determinamos si tenemos prdidas o no
    if (tan_perd == 0)
        delta_tan = 0;
        dC_tan = 0;
        tan_final = 1;
    else
        delta_tan = delta_tan_perd;
        dC_tan = 0.1;
    end
    
    % Clculo de valores ptimos
    [s11_opt, s21_opt] = funcion_s(er_opt,tan_perd_opt,frecuencia);

    % Clculo de valores iniciales 
    [s11_inc_er, s21_inc_er] = funcion_s(er+delta_er,tan_perd,frecuencia);
    [s11_inc_tan, s21_inc_tan] = funcion_s(er,tan_perd+delta_tan,frecuencia);
    [s11, s21] = funcion_s(er,tan_perd,frecuencia);

    % Clculo de la diferencia entre el valor ptimo y el calculado
    diferencia_er = abs(er_opt-er);
    diferencia_tan = abs(tan_perd_opt-tan_perd);

    % Bucle de optimizacin     
    while (coste_act ~= 0) 

       % Evaluacin de la funcin coste
       coste_act = (sum(abs(s11_opt-s11)))*eta+(sum(abs(s21_opt-s21)))*chi;
%        vector_coste = [vector_coste coste_act];
       coste_inc_er = (sum(abs(s11_opt-s11_inc_er)))*eta+(sum(abs(s21_opt-s21_inc_er)))*chi;
       coste_inc_tan = (sum(abs(s11_opt-s11_inc_tan)))*eta+(sum(abs(s21_opt-s21_inc_tan)))*chi;

       % Clculo del incremento de la tangente de prdidas
         if (tan_perd ~= 0)
             if (diferencia_tan < 0.0009)
                 dC_tan = 0;
                 tan_final = 1;
             else
                 dC_tan = (coste_act-coste_inc_tan)/delta_tan;
             end
           tan_perd = tan_perd+mu*dC_tan;
%            vector_tan_perd = [vector_tan_perd tan_perd];              
         end

        % Clculo del incremento de er
        if (diferencia_er < 0.1)
             dC_er = 0;
             er_final = 1;
        else
            dC_er = (coste_act-coste_inc_er)/delta_er; % Dividimos para caso sin perdidas
        end
        er = er+mu*dC_er;
%         vector_er = [vector_er er];
    
        % Evaluacin de la diferencia de tangentes
        diferencia_tan = abs(tan_perd_opt-tan_perd);
           if (diferencia_tan < 0.0009)
                tan_final = 1;
           end

        % Evaluacin de la diferencia de er
        diferencia_er = abs(er_opt-er);
         if (diferencia_er < 0.1)
                er_final = 1;
         end

         % Clculo de los nuevos valores de los parmetros S    
        [s11_inc_er, s21_inc_er] = funcion_s(er+delta_er,tan_perd,frecuencia);
        [s11_inc_tan, s21_inc_tan] = funcion_s(er,tan_perd+delta_tan,frecuencia);
        [s11,s21] = funcion_s(er,tan_perd,frecuencia);

        % Condicin de parada del algoritmo
         if (er_final == 1 && tan_final == 1)
            coste_act = (sum(abs(s11_opt-s11)))*eta+(sum(abs(s21_opt-s21)))*chi;
%             vector_coste = [vector_coste coste_act];
            iteracion = iteracion+1;
            break
         end 

        % Incremento del contador de iteraciones
       iteracion = iteracion+1;

       % Nmero mximo de iteraciones
       if iteracion == 1000
          break
       end

    end
%             vector_coste = [vector_coste coste_act];
%         vector_iteracion = [vector_iteracion iteracion];
%     
%     
% end
% 
% 
%     % Conversion a dB
%     s21_opt_db = 20*log10(abs(s21_opt));
%     s21_db = 20*log10(abs(s21));
%     s11_opt_db = 20*log10(abs(s11_opt));
%     s11_db = 20*log10(abs(s11));
% 
%     % Representacin de resultados CASTELLANO
%     figure, plot(frecuencia, s21_opt_db,'o-');
%     hold on
%     plot(frecuencia, s11_opt_db,'o-');
%     plot(frecuencia, s21_db,'.-g');
%     plot(frecuencia,s11_db,'.-g'); legend('S21 opt','S11 opt','S21','S11')
%     xlabel('Frecuencia (Hz)')
%     ylabel('Parmetros S (dB)')
% %     title('Descenso por gradiente: Parmetros S (Sin prdidas)')
%     title('Descenso por gradiente: Parmetros S (Con prdidas)')
%     hold off
% % 
%     vector_iteracion = 1:iteracion;
%     figure, plot(vector_iteracion, vector_coste,'.-')
% %     title('Descenso por gradiente: Evolucin del coste (Sin prdidas)');
%     title('Descenso por gradiente: Evolucin del coste (Con prdidas)');
%     xlabel('Iteraciones')
%     ylabel('Coste')
% 
%     figure, plot(vector_iteracion,vector_er,'.-')
% %     title('Descenso por gradiente: Evolucin de Er (Sin prdidas)')
%     title('Descenso por gradiente: Evolucin de Er (Con prdidas)')
%     xlabel('Iteraciones')
%     ylabel('Er')
% 
%     figure, plot(vector_iteracion,vector_tan_perd,'.-')
%     title('Descenso por gradiente: Evolucin de la tangente (Con prdidas)');
%     xlabel('Iteraciones')
%     ylabel('Tangente de prdidas')      

%     % Representacin de resultados INGLES
%     figure, plot(frecuencia, s21_opt_db,'o-');
%     hold on
%     plot(frecuencia, s11_opt_db,'o-');
%     plot(frecuencia, s21_db,'.-g');
%     plot(frecuencia,s11_db,'.-g'); legend('S21 ideal','S11 ideal','S21','S11')
%     xlabel('Frequency (Hz)')
%     ylabel('S-Parameters (dB)')
%     %         title('Gradient Descent: S-Parameters (Simple permittivity)')
%     title('Gradient Descent: S-Parameters (Complex permittivity)')
%     hold off
% 
%     vector_iteracion = 1:iteracion;
%     figure, plot(vector_iteracion, vector_coste,'.-')
%     %         title('Gradient Descent: Cost Evolution (Simple permittivity)');
%     title('Gradient Descent: Cost Evolution (Complex permittivity)');
%     xlabel('Iterations')
%     ylabel('Cost')
% 
%     figure, plot(vector_iteracion, vector_er,'.-')
%     %         title('Gradient Descent: Er Evolution (Simple permittivity)');
%     title('Gradient Descent: Er Evolution (Complex permittivity)');
%     xlabel('Iterations')
%     ylabel('Er')
% 
%     figure, plot(vector_iteracion,vector_tan_perd,'.-')
%     title('Gradient Descent: tan(delta) Evolution (Complex permittivity)');
%     xlabel('Iterations')
%     ylabel('Tan(delta)')  

end

